program checkoutput
use dal
use errorhandling

implicit none

type(DataSetT)  :: listDataSet
type(TableT)    :: tableDataSet
type(ColumnT)   :: listColumn1,listColumn2,listColumn3,listColumn4
type(ColumnT)   :: listColumn5, listColumn6, listColumn7, listColumn8
real(kind=single), pointer :: xpos(:),ypos(:),poserr(:),counts(:),cerr(:)
real(kind=single), pointer :: sigX(:), sigY(:),pa(:)
real, allocatable :: xSource(:), ySource(:), cSource(:)
real, allocatable :: sigXSource(:), sigYSource(:),paSource(:)
integer :: nSource
integer :: nFound
real :: chiSqr
integer :: i,j,nrows
real :: dist
logical, allocatable :: Found(:)
integer :: thisSource
real :: mindist

character(len=32) :: xpout
character(len=32) :: ypout

listDataSet = dataSet("testlist.fts", read)
tableDataSet = table(listDataSet, "SRCLIST")
nrows = numberofRows(tableDataSet)

listColumn1 = column(tableDataSet, "XPOS",read)
xpos => real32Data(listColumn1)
listColumn2 = column(tableDataSet, "YPOS",read)
ypos => real32Data(listColumn2)
listColumn3 = column(tableDataSet, "POSERR",read)
poserr => real32Data(listColumn3)
listColumn4 = column(tableDataSet, "RATE",read)
counts => real32Data(listColumn4)
listColumn5 = column(tableDataSet, "RATE_ERR",read)
cerr => real32Data(listColumn5)
listColumn6 = column(tableDataSet, "FWHM_MAJ",read)
sigX => real32Data(listColumn6)
listColumn7 = column(tableDataSet, "FWHM_MIN",read)
sigY => real32Data(listColumn7)
listColumn8 = column(tableDataSet, "PA",read)
pa => real32Data(listColumn8)

open(20,file="testimage.lis",status="old",form="formatted")

read(20,*) nSource
write(*,*)'CHECK nSource = ',nSource
allocate(xSource(nSource))
allocate(ySource(nSource))
allocate(cSource(nSource))
allocate(sigXSource(nSource))
allocate(sigYSource(nSource))
allocate(paSource(nSource))
allocate(Found(nSource))

Found = .false.

do i = 1, nSource
   read(20,*) xSource(i), ySource(i), cSource(i), sigXsource(i), &
              sigYsource(i), paSource(i)
enddo
close(20)

nFound = 0


chiSqr = 0.
do i = 1, nSource

  mindist = 1.e30
  do j = 0, nrows-1
     write (xpout,*) xpos(j)
     write (ypout,*) ypos(j)                                     
     if (scan(xpout,"NaN") .eq. 0 .and. scan(ypout,"NaN") .eq. 0 ) then
       dist = sqrt( (xSource(i) - xpos(j))**2 + (ySource(i)-ypos(j))**2)
       if (dist < mindist) then
          mindist = dist
          thissource = j
       endif
     endif
  enddo
  if (mindist .lt. 25.*poserr(thissource)) then
        nFound = nFound + 1
        chiSqr = chiSqr + ((cSource(i) - counts(thissource))/sqrt(cSource(i)))**2
  else
     call warning("notFound","source not found in test image")
  endif
enddo

close(21)

chiSqr = chiSqr / real(nFound-1)

write(*,*) "ChiSqr of flux values: ",chiSqr
write(*,*) "Number of sources in test image: ", nSource
write(*,*) "Number of sources found by omdetect: ", nFound

if (abs(real(nFound-nSource)/real(nSource)) > 0.30) then
  call fatal("wrongNumberOfSources", "Wrong number of sources found in test image")
endif

call release(listColumn1)
call release(listColumn2)
call release(listColumn3)
call release(listColumn4)
call release(listColumn5)
call release(listColumn6)
call release(listColumn7)
call release(listColumn8)
call release(tableDataSet)
call release(listDataSet)
end
